# Spring Boot 2 Fundamentals
Code bundles for Spring Boot 2 Fundamentals, published by Packt.

Code Bundles for Courseware on Spring Boot 2 Fundamentals – Patrick Cornelißen, Michael Piefel, and Alexander Sparkowsky. 

You will begin the Spring Boot Fundamentals course by learning how to write and test simple code using the Spring Framework and then use this skill to learn advanced concepts, such as creating an HTML-based frontend with dynamic data and HTML forms. Then, you will create a simple, working, web interface to display blog posts, list all articles, and create and edit blog articles. You will learn to work with the REST API functionality that Spring Boot offers and secure your blogging application. At the end of the course, you will learn how to persist your blog posts in a database, bringing everything together as a full web application with the complete functionality of a professional solution. 

## What you will learn
*	Create your own Spring Boot application from scratch
* Write comprehensive unit tests for your applications
*	Learn how to store data in a relational database
*	Create your own RESTful API with Spring Boot 
*	Create a rich web interface for your applications
*	Secure your application with Spring Security

### Hardware requirements
For an optimal student experience, we recommend the following hardware configuration:
* Processor: Intel Core i7 or equivalent
* Memory: 8 GB RAM
* Storage: 15 GB available space

#### Software requirements
You’ll also need the following software installed in advance:
* Operating system: Windows 7 SP1 64-bit, Windows 8.1 64-bit or Windows 10 64-bit, macOS High Sierra or Linux
* Browser: Google Chrome, Latest Version
* IntelliJ Community Edition (or Ultimate), Latest Version
* JDK 8+
* Maven 3.3+


